diff -rNbu binutils_060913_org/bfd/config.bfd binutils_060913/bfd/config.bfd
--- binutils_060913_org/bfd/config.bfd	2006-08-21 10:12:44.000000000 +0200
+++ binutils_060913/bfd/config.bfd	2006-09-11 11:25:34.000000000 +0200
@@ -98,7 +98,7 @@
 strongarm*)	 targ_archs=bfd_arm_arch ;;
 thumb*)		 targ_archs=bfd_arm_arch ;;
 v850*)		 targ_archs=bfd_v850_arch ;;
-x86_64)		 targ_archs=bfd_i386_arch ;;
+x86_64*)		 targ_archs=bfd_i386_arch ;;
 xscale*)	 targ_archs=bfd_arm_arch ;;
 xtensa*)	 targ_archs=bfd_xtensa_arch ;;
 z80|r800)	 targ_archs=bfd_z80_arch ;;
@@ -578,6 +578,12 @@
     targ_selvecs="bfd_elf32_i386_vec i386linux_vec bfd_efi_app_ia32_vec"
     want64=true
     ;;
+  x86_64-*-mingw64*)
+    targ_defvec=x86_64pe_vec
+    targ_selvecs="x86_64pe_vec x86_64pei_vec x86_64coff_vec  bfd_elf64_x86_64_vec"
+    want64=true
+    targ_underscore=yes
+    ;;
 #endif
   i[3-7]86-*-lynxos*)
     targ_defvec=bfd_elf32_i386_vec
diff -rNbu binutils_060913_org/bfd/configure.in binutils_060913/bfd/configure.in
--- binutils_060913_org/bfd/configure.in	2006-08-21 10:12:45.000000000 +0200
+++ binutils_060913/bfd/configure.in	2006-09-11 11:37:22.000000000 +0200
@@ -739,6 +739,7 @@
     i386aout_vec)		tb="$tb i386aout.lo aout32.lo" ;;
     i386bsd_vec)		tb="$tb i386bsd.lo aout32.lo" ;;
     i386coff_vec)		tb="$tb coff-i386.lo cofflink.lo" ;;
+    x86_64coff_vec)		tb="$tb coff-x86_64.lo cofflink.lo"; target_size=64 ;;
     i386dynix_vec)		tb="$tb i386dynix.lo aout32.lo" ;;
     i386freebsd_vec)		tb="$tb i386freebsd.lo aout32.lo" ;;
     i386linux_vec)		tb="$tb i386linux.lo aout32.lo" ;;
@@ -749,7 +750,9 @@
     i386netbsd_vec)		tb="$tb i386netbsd.lo aout32.lo" ;;
     i386os9k_vec)		tb="$tb i386os9k.lo aout32.lo" ;;
     i386pe_vec)			tb="$tb pe-i386.lo peigen.lo cofflink.lo" ;;
+    x86_64pe_vec)			tb="$tb pe-x86_64.lo pex64igen.lo cofflink.lo"; target_size=64 ;;
     i386pei_vec)		tb="$tb pei-i386.lo peigen.lo cofflink.lo" ;;
+    x86_64pei_vec)		tb="$tb pei-x86_64.lo pex64igen.lo cofflink.lo"; target_size=64 ;;
     i860coff_vec)		tb="$tb coff-i860.lo cofflink.lo" ;;
     icoff_big_vec)		tb="$tb coff-i960.lo cofflink.lo" ;;
     icoff_little_vec)		tb="$tb coff-i960.lo cofflink.lo" ;;
diff -rNbu binutils_060913_org/bfd/libpei.h binutils_060913/bfd/libpei.h
--- binutils_060913_org/bfd/libpei.h	2005-05-04 17:53:35.000000000 +0200
+++ binutils_060913/bfd/libpei.h	2006-09-11 11:42:22.000000000 +0200
@@ -204,6 +204,38 @@
 #define PUT_SCNHDR_LNNOPTR H_PUT_32
 #endif
 
+#ifdef COFF_WITH_pex64
+#define GET_OPTHDR_IMAGE_BASE H_GET_64
+#define PUT_OPTHDR_IMAGE_BASE H_PUT_64
+#define GET_OPTHDR_SIZE_OF_STACK_RESERVE H_GET_64
+#define PUT_OPTHDR_SIZE_OF_STACK_RESERVE H_PUT_64
+#define GET_OPTHDR_SIZE_OF_STACK_COMMIT H_GET_64
+#define PUT_OPTHDR_SIZE_OF_STACK_COMMIT H_PUT_64
+#define GET_OPTHDR_SIZE_OF_HEAP_RESERVE H_GET_64
+#define PUT_OPTHDR_SIZE_OF_HEAP_RESERVE H_PUT_64
+#define GET_OPTHDR_SIZE_OF_HEAP_COMMIT H_GET_64
+#define PUT_OPTHDR_SIZE_OF_HEAP_COMMIT H_PUT_64
+#define GET_PDATA_ENTRY bfd_get_32
+
+#define _bfd_XX_bfd_copy_private_bfd_data_common	_bfd_pex64_bfd_copy_private_bfd_data_common
+#define _bfd_XX_bfd_copy_private_section_data		_bfd_pex64_bfd_copy_private_section_data
+#define _bfd_XX_get_symbol_info				_bfd_pex64_get_symbol_info
+#define _bfd_XX_only_swap_filehdr_out			_bfd_pex64_only_swap_filehdr_out
+#define _bfd_XX_print_private_bfd_data_common		_bfd_pex64_print_private_bfd_data_common
+#define _bfd_XXi_final_link_postscript			_bfd_pex64i_final_link_postscript
+#define _bfd_XXi_final_link_postscript			_bfd_pex64i_final_link_postscript
+#define _bfd_XXi_only_swap_filehdr_out			_bfd_pex64i_only_swap_filehdr_out
+#define _bfd_XXi_swap_aouthdr_in			_bfd_pex64i_swap_aouthdr_in
+#define _bfd_XXi_swap_aouthdr_out			_bfd_pex64i_swap_aouthdr_out
+#define _bfd_XXi_swap_aux_in				_bfd_pex64i_swap_aux_in
+#define _bfd_XXi_swap_aux_out				_bfd_pex64i_swap_aux_out
+#define _bfd_XXi_swap_lineno_in				_bfd_pex64i_swap_lineno_in
+#define _bfd_XXi_swap_lineno_out			_bfd_pex64i_swap_lineno_out
+#define _bfd_XXi_swap_scnhdr_out			_bfd_pex64i_swap_scnhdr_out
+#define _bfd_XXi_swap_sym_in				_bfd_pex64i_swap_sym_in
+#define _bfd_XXi_swap_sym_out				_bfd_pex64i_swap_sym_out
+
+#else /* !COFF_WITH_pex64 */
 #ifdef COFF_WITH_pep
 
 #define GET_OPTHDR_IMAGE_BASE H_GET_64
@@ -269,6 +301,7 @@
 #define _bfd_XXi_swap_sym_out				_bfd_pei_swap_sym_out
 
 #endif /* !COFF_WITH_pep */
+#endif /* !COFF_WITG_pex64 */
 
 /* Macro: Returns true if the bfd is a PE executable as opposed to a PE object file.  */
 #define bfd_pe_executable_p(abfd) \
diff -rNbu binutils_060913_org/bfd/pe-x86_64.c binutils_060913/bfd/pe-x86_64.c
--- binutils_060913_org/bfd/pe-x86_64.c	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/bfd/pe-x86_64.c	2006-09-06 12:23:54.000000000 +0200
@@ -0,0 +1,54 @@
+/* BFD back-end for Intel/AMD x86_64 PECOFF files.
+   Copyright 1995, 1996, 1999, 2001, 2002, 2004 Free Software Foundation, Inc.
+
+   This file is part of BFD, the Binary File Descriptor library.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
+   
+   Written by Kai Tietz, OneVision Software GmbH&CoKg.
+*/
+
+#include "bfd.h"
+#include "sysdep.h"
+
+#define TARGET_SYM 		x86_64pe_vec
+#define TARGET_NAME 		"pe-x86-64"
+#define COFF_WITH_PE
+#define COFF_WITH_pex64
+#define PCRELOFFSET 		TRUE
+#define TARGET_UNDERSCORE 	'_'
+#define COFF_LONG_SECTION_NAMES
+#define COFF_SUPPORT_GNU_LINKONCE
+#define COFF_LONG_FILENAMES
+
+#define COFF_SECTION_ALIGNMENT_ENTRIES \
+{ COFF_SECTION_NAME_EXACT_MATCH (".bss"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".data"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".rdata"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".text"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_PARTIAL_MATCH (".idata"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 2 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".pdata"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 2 }, \
+{ COFF_SECTION_NAME_PARTIAL_MATCH (".debug"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 0 }, \
+{ COFF_SECTION_NAME_PARTIAL_MATCH (".gnu.linkonce.wi."), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 0 }
+
+#include "coff-x86_64.c"
diff -rNbu binutils_060913_org/bfd/peXXigen.c binutils_060913/bfd/peXXigen.c
--- binutils_060913_org/bfd/peXXigen.c	2006-07-24 18:51:26.000000000 +0200
+++ binutils_060913/bfd/peXXigen.c	2006-09-11 13:29:26.000000000 +0200
@@ -52,7 +52,7 @@
    on this code has a chance of getting something accomplished without
    wasting too much time.  */
 
-/* This expands into COFF_WITH_pe or COFF_WITH_pep depending on whether
+/* This expands into COFF_WITH_pe, COFF_WITH_pep, or COFF_WITH_pex64 depending on whether
    we're compiling for straight PE or PE+.  */
 #define COFF_WITH_XX
 
@@ -67,17 +67,21 @@
    within PE/PEI, so we get them from there.  FIXME: The lack of
    variance is an assumption which may prove to be incorrect if new
    PE/PEI targets are created.  */
-#ifdef COFF_WITH_pep
-# include "coff/ia64.h"
+#ifdef COFF_WITH_pex64
+# include "coff/x86_64.h"
 #else
+# ifdef COFF_WITH_pep
+#  include "coff/ia64.h"
+# else
 # include "coff/i386.h"
+# endif
 #endif
 
 #include "coff/pe.h"
 #include "libcoff.h"
 #include "libpei.h"
 
-#ifdef COFF_WITH_pep
+#if defined(COFF_WITH_pep) || defined(COFF_WITH_pex64)
 # undef AOUTSZ
 # define AOUTSZ		PEPAOUTSZ
 # define PEAOUTHDR	PEPAOUTHDR
@@ -399,7 +403,7 @@
   aouthdr_int->entry = GET_AOUTHDR_ENTRY (abfd, aouthdr_ext->entry);
   aouthdr_int->text_start =
     GET_AOUTHDR_TEXT_START (abfd, aouthdr_ext->text_start);
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
   /* PE32+ does not have data_start member!  */
   aouthdr_int->data_start =
     GET_AOUTHDR_DATA_START (abfd, aouthdr_ext->data_start);
@@ -455,7 +459,7 @@
   if (aouthdr_int->entry)
     {
       aouthdr_int->entry += a->ImageBase;
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
       aouthdr_int->entry &= 0xffffffff;
 #endif
     }
@@ -463,12 +467,12 @@
   if (aouthdr_int->tsize)
     {
       aouthdr_int->text_start += a->ImageBase;
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
       aouthdr_int->text_start &= 0xffffffff;
 #endif
     }
 
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
   /* PE32+ does not have data_start member!  */
   if (aouthdr_int->dsize)
     {
@@ -548,7 +552,7 @@
   if (aouthdr_in->tsize)
     {
       aouthdr_in->text_start -= ib;
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
       aouthdr_in->text_start &= 0xffffffff;
 #endif
     }
@@ -556,7 +560,7 @@
   if (aouthdr_in->dsize)
     {
       aouthdr_in->data_start -= ib;
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
       aouthdr_in->data_start &= 0xffffffff;
 #endif
     }
@@ -564,7 +568,7 @@
   if (aouthdr_in->entry)
     {
       aouthdr_in->entry -= ib;
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
       aouthdr_in->entry &= 0xffffffff;
 #endif
     }
@@ -661,7 +665,7 @@
   PUT_AOUTHDR_TEXT_START (abfd, aouthdr_in->text_start,
 			  aouthdr_out->standard.text_start);
 
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
   /* PE32+ does not have data_start member!  */
   PUT_AOUTHDR_DATA_START (abfd, aouthdr_in->data_start,
 			  aouthdr_out->standard.data_start);
@@ -1262,6 +1266,35 @@
 	    }
 
 	  /* Print HintName vector entries.  */
+#ifdef COFF_WITH_pex64
+	  for (j = 0; j < datasize; j += 8)
+	    {
+			unsigned long member = bfd_get_32(abfd,data+idx+j);
+			unsigned long member_high = bfd_get_32(abfd,data+idx+j+4);
+			if(!member && !member_high) break;
+	      if (member_high & 0x80000000)
+		fprintf (file, "\t%lx%08lx\t %4lx%08lx  <none>",
+			 member_high,member, member_high & 0x7fffffff,member);
+	      else
+		{
+		  int ordinal;
+		  char *member_name;
+
+		  ordinal = bfd_get_16 (abfd, data + member - adj);
+		  member_name = (char *) data + member - adj + 2;
+		  fprintf (file, "\t%04lx\t %4d  %s",member, ordinal, member_name);
+		  }
+
+	      /* If the time stamp is not zero, the import address
+		 table holds actual addresses.  */
+	      if (time_stamp != 0
+		  && first_thunk != 0
+		  && first_thunk != hint_addr)
+		fprintf (file, "\t%04lx",
+			 (long) bfd_get_32 (abfd, ft_data + ft_idx + j));
+	      fprintf (file, "\n");
+	    }
+#else
 	  for (j = 0; j < datasize; j += 4)
 	    {
 	      unsigned long member = bfd_get_32 (abfd, data + idx + j);
@@ -1294,6 +1327,7 @@
 
 	      fprintf (file, "\n");
 	    }
+#endif /* !defined(COFF_WITH_pex64) */
 
 	  if (ft_allocated)
 	    free (ft_data);
@@ -1534,7 +1568,7 @@
 static bfd_boolean
 pe_print_pdata (bfd * abfd, void * vfile)
 {
-#ifdef COFF_WITH_pep
+#if defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
 # define PDATA_ROW_SIZE	(3*8)
 #else
 # define PDATA_ROW_SIZE	(5*4)
@@ -1560,7 +1594,7 @@
 
   fprintf (file,
 	   _("\nThe Function Table (interpreted .pdata section contents)\n"));
-#ifdef COFF_WITH_pep
+#if defined(COFF_WITH_pep) && !defined(COFF_WITH_pex64)
   fprintf (file,
 	   _(" vma:\t\t\tBegin Address    End Address      Unwind Info\n"));
 #else
@@ -1614,7 +1648,7 @@
       fprintf_vma (file, begin_addr); fputc (' ', file);
       fprintf_vma (file, end_addr); fputc (' ', file);
       fprintf_vma (file, eh_handler);
-#ifndef COFF_WITH_pep
+#if !defined(COFF_WITH_pep) || defined(COFF_WITH_pex64)
       fputc (' ', file);
       fprintf_vma (file, eh_data); fputc (' ', file);
       fprintf_vma (file, prolog_end_addr);
diff -rNbu binutils_060913_org/bfd/pei-x86_64.c binutils_060913/bfd/pei-x86_64.c
--- binutils_060913_org/bfd/pei-x86_64.c	1970-01-01 01:00:00.000000000 +0100
+++ binutils_060913/bfd/pei-x86_64.c	2006-09-06 12:23:58.000000000 +0200
@@ -0,0 +1,55 @@
+/* BFD back-end for Intel 386 PE IMAGE COFF files.
+   Copyright 1995, 1996, 1999, 2001, 2002, 2004 Free Software Foundation, Inc.
+
+   This file is part of BFD, the Binary File Descriptor library.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
+   
+   Written by Kai Tietz, OneVision Software GmbH&CoKg.
+*/
+
+#include "bfd.h"
+#include "sysdep.h"
+
+#define TARGET_SYM 		x86_64pei_vec
+#define TARGET_NAME 		"pei-x86-64"
+#define COFF_IMAGE_WITH_PE
+#define COFF_WITH_PE
+#define COFF_WITH_pex64
+#define PCRELOFFSET 		TRUE
+#define TARGET_UNDERSCORE 	'_'
+#define COFF_LONG_SECTION_NAMES
+#define COFF_SUPPORT_GNU_LINKONCE
+#define COFF_LONG_FILENAMES
+
+#define COFF_SECTION_ALIGNMENT_ENTRIES \
+{ COFF_SECTION_NAME_EXACT_MATCH (".bss"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".data"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".rdata"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".text"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 4 }, \
+{ COFF_SECTION_NAME_PARTIAL_MATCH (".idata"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 2 }, \
+{ COFF_SECTION_NAME_EXACT_MATCH (".pdata"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 2 }, \
+{ COFF_SECTION_NAME_PARTIAL_MATCH (".debug"), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 0 }, \
+{ COFF_SECTION_NAME_PARTIAL_MATCH (".gnu.linkonce.wi."), \
+  COFF_ALIGNMENT_FIELD_EMPTY, COFF_ALIGNMENT_FIELD_EMPTY, 0 }
+
+#include "coff-x86_64.c"
diff -rNbu binutils_060913_org/bfd/peicode.h binutils_060913/bfd/peicode.h
--- binutils_060913_org/bfd/peicode.h	2005-05-04 17:53:37.000000000 +0200
+++ binutils_060913/bfd/peicode.h	2006-09-11 11:58:24.000000000 +0200
@@ -183,7 +183,15 @@
 #ifdef COFF_IMAGE_WITH_PE
 # define coff_swap_filehdr_out _bfd_XXi_only_swap_filehdr_out
 #else
+# ifdef COFF_WITH_pex64
+#  define coff_swap_filehdr_out _bfd_pex64_only_swap_filehdr_out
+# else
+#  ifdef COFF_WITH_pep
+#   define coff_swap_filehdr_out _bfd_pep_only_swap_filehdr_out
+#  else
 # define coff_swap_filehdr_out _bfd_pe_only_swap_filehdr_out
+#  endif
+# endif
 #endif
 
 static void
@@ -217,7 +225,10 @@
   if (scnhdr_int->s_vaddr != 0)
     {
       scnhdr_int->s_vaddr += pe_data (abfd)->pe_opthdr.ImageBase;
+      /* Do not cut upper 32 bit for 64 vma */
+#ifndef COFF_WITH_pex64
       scnhdr_int->s_vaddr &= 0xffffffff;
+#endif
     }
 
 #ifndef COFF_NO_HACK_SCNHDR_SIZE
@@ -405,8 +416,16 @@
 					+ NUM_ILF_SECTIONS * 9 \
 					+ STRING_SIZE_SIZE)
 #define SIZEOF_IDATA2		(5 * 4)
+
+/* For PE+ idata4 & 5 have thumb size of 8 bytes ! */
+#ifndef COFF_WITH_pex64
 #define SIZEOF_IDATA4		(1 * 4)
 #define SIZEOF_IDATA5		(1 * 4)
+#else
+#define SIZEOF_IDATA4		(2 * 4)
+#define SIZEOF_IDATA5		(2 * 4)
+#endif
+
 #define SIZEOF_IDATA6		(2 + strlen (symbol_name) + 1 + 1)
 #define SIZEOF_IDATA7		(strlen (source_dll) + 1 + 1)
 #define SIZEOF_ILF_SECTIONS     (NUM_ILF_SECTIONS * sizeof (struct coff_section_tdata))
@@ -656,6 +675,13 @@
   },
 #endif
 
+#ifdef AMD64MAGIC
+  { AMD64MAGIC,
+  { 0xff,0x25,0x00,0x00,0x00,0x00,0x90,0x90 },
+  8,2
+  },
+#endif
+
 #ifdef  MC68MAGIC
   { MC68MAGIC, { /* XXX fill me in */ }, 0, 0 },
 #endif
@@ -830,8 +856,15 @@
 	/* XXX - treat as IMPORT_NAME ??? */
 	abort ();
 
+#ifndef COFF_WITH_pex64
       * (unsigned int *) id4->contents = ordinal | 0x80000000;
       * (unsigned int *) id5->contents = ordinal | 0x80000000;
+#else
+      * (unsigned int *) id4->contents = ordinal;
+	  ((unsigned int *) id4->contents)[1] = 0x80000000;
+      * (unsigned int *) id5->contents = ordinal;
+      ((unsigned int *) id5->contents)[1] = 0x80000000;
+#endif
     }
   else
     {
@@ -1071,6 +1104,12 @@
 #endif
       break;
 
+	case IMAGE_FILE_MACHINE_AMD64:
+#ifdef AMD64MAGIC
+		magic=AMD64MAGIC;
+#endif
+		break;
+
     case IMAGE_FILE_MACHINE_M68K:
 #ifdef MC68AGIC
       magic = MC68MAGIC;
diff -rNbu binutils_060913_org/bfd/targets.c binutils_060913/bfd/targets.c
--- binutils_060913_org/bfd/targets.c	2006-08-21 10:12:45.000000000 +0200
+++ binutils_060913/bfd/targets.c	2006-09-11 12:28:24.000000000 +0200
@@ -789,6 +789,9 @@
 extern const bfd_target we32kcoff_vec;
 extern const bfd_target z80coff_vec;
 extern const bfd_target z8kcoff_vec;
+extern const bfd_target x86_64pe_vec;
+extern const bfd_target x86_64pei_vec;
+extern const bfd_target x86_64coff_vec;
 
 /* These are always included.  */
 extern const bfd_target srec_vec;
@@ -1033,6 +1036,11 @@
 #if 0
 	&i386dynix_vec,
 #endif
+#ifdef BFD64
+	&x86_64coff_vec,
+	&x86_64pe_vec,
+	&x86_64pei_vec,
+#endif
 	&i386freebsd_vec,
 #if 0
 	/* Since a.out files lack decent magic numbers, no way to recognize
diff -rNbu binutils_060913_org/binutils/ChangeLog binutils_060913/binutils/ChangeLog
--- binutils_060913_org/binutils/ChangeLog	2006-09-11 16:40:39.000000000 +0200
+++ binutils_060913/binutils/ChangeLog	2006-09-13 11:06:00.000000000 +0200
@@ -1,3 +1,15 @@
+2006-09-13	Kai Tietz	<Kai.Tietz@onevision.com>
+
+	* configure.in:	Add new target x86_64-pc-mingw64
+	* dlltool.c:	Adjust include for this target
+		DLLTOOL_MX86_64:	Added macro to handle target specific code
+		mname:					Added default target static as "i386:x86-64"
+		MX86:					Added macro for target ident
+		mtable:				Added target specific definitions
+		rvaafter:			Add handling of MX86
+		rvabefore:			Add handling of MX86
+		asmprefix:			Add handling of MX86
+
 2006-09-09  Nick Clifton  <nickc@redhat.com>
 
 	PR binutils/3110
diff -rNbu binutils_060913_org/binutils/configure.in binutils_060913/binutils/configure.in
--- binutils_060913_org/binutils/configure.in	2006-08-21 10:12:45.000000000 +0200
+++ binutils_060913/binutils/configure.in	2006-09-11 13:33:20.000000000 +0200
@@ -265,6 +265,14 @@
 	  BUILD_WINDRES='$(WINDRES_PROG)$(EXEEXT)'
 	  BUILD_DLLWRAP='$(DLLWRAP_PROG)$(EXEEXT)'
 	  ;;
+	x86_64-*-mingw64*)
+changequote([,])dnl
+  	  BUILD_DLLTOOL='$(DLLTOOL_PROG)$(EXEEXT)'
+	  DLLTOOL_DEFS="$DLLTOOL_DEFS -DDLLTOOL_MX86_64"
+	  BUILD_WINDRES='$(WINDRES_PROG)$(EXEEXT)'
+	  BUILD_DLLWRAP='$(DLLWRAP_PROG)$(EXEEXT)'
+	  ;;
+changequote(,)dnl
 changequote(,)dnl
 	i[3-7]86-*-interix)
 changequote([,])dnl
diff -rNbu binutils_060913_org/binutils/dlltool.c binutils_060913/binutils/dlltool.c
--- binutils_060913_org/binutils/dlltool.c	2006-08-21 10:12:45.000000000 +0200
+++ binutils_060913/binutils/dlltool.c	2006-09-11 13:47:12.000000000 +0200
@@ -261,6 +261,9 @@
 #include "coff/arm.h"
 #include "coff/internal.h"
 #endif
+#ifdef DLLTOOL_MX86_64
+#include "coff/x86_64.h"
+#endif
 
 /* Forward references.  */
 static char *look_for_prog (const char *, const char *, int);
@@ -398,6 +401,10 @@
 static const char *mname = "i386";
 #endif
 
+#ifdef DLLTOOL_MX86_64
+static const char *mname = "i386:x86-64";
+#endif
+
 #ifdef DLLTOOL_PPC
 static const char *mname = "ppc";
 #endif
@@ -640,6 +647,14 @@
     arm_jtab, sizeof (arm_jtab), 8
   }
   ,
+  {
+#define MX86 11
+    "i386:x86-64", ".byte", ".short", ".long", ".asciz", "#",
+    "jmp *", ".global", ".space", ".align\t2",".align\t4", "",
+    "pe-x86-64",bfd_arch_i386,
+    i386_jtab, sizeof (i386_jtab), 2
+  }
+  ,
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
 };
 
@@ -763,6 +778,7 @@
     {
     case MARM:
     case M386:
+	case MX86:
     case MPPC:
     case MTHUMB:
     case MARM_INTERWORK:
@@ -788,6 +804,7 @@
     {
     case MARM:
     case M386:
+	case MX86:
     case MPPC:
     case MTHUMB:
     case MARM_INTERWORK:
@@ -823,6 +840,7 @@
     case MARM_WINCE:
       break;
     case M386:
+	case MX86:
       /* Symbol names starting with ? do not have a leading underscore. */
       if (name && *name == '?')
         break;
@@ -1701,9 +1719,18 @@
     {
       fprintf (filvar, "listone%d:\n", headindex);
       for ( funcindex = 0; funcindex < headptr->nfuncs; funcindex++ )
+#ifdef DLLTOOL_MX86_64
+	fprintf (filvar, "\t%sfuncptr%d_%d%s\n%s\t0\n",
+		 ASM_RVA_BEFORE, headindex, funcindex, ASM_RVA_AFTER,ASM_LONG);
+#else
 	fprintf (filvar, "\t%sfuncptr%d_%d%s\n",
 		 ASM_RVA_BEFORE, headindex, funcindex, ASM_RVA_AFTER);
+#endif
+#ifdef DLLTOOL_MX86_64
+      fprintf (filvar,"\t%s\t0\n\t%s\t0\n", ASM_LONG, ASM_LONG); /* NULL terminating list */
+#else
       fprintf (filvar,"\t%s\t0\n", ASM_LONG); /* NULL terminating list */
+#endif
       headindex++;
     }
 
@@ -1713,9 +1740,18 @@
     {
       fprintf (filvar, "listtwo%d:\n", headindex);
       for ( funcindex = 0; funcindex < headptr->nfuncs; funcindex++ )
+#ifdef DLLTOOL_MX86_64
+	fprintf (filvar, "\t%sfuncptr%d_%d%s\n%s\t0\n",
+		 ASM_RVA_BEFORE, headindex, funcindex, ASM_RVA_AFTER,ASM_LONG);
+#else
 	fprintf (filvar, "\t%sfuncptr%d_%d%s\n",
 		 ASM_RVA_BEFORE, headindex, funcindex, ASM_RVA_AFTER);
-      fprintf (filvar, "\t%s\t0\n", ASM_LONG); /* NULL terminating list */
+#endif
+#ifdef DLLTOOL_MX86_64
+      fprintf (filvar,"\t%s\t0\n\t%s\t0\n", ASM_LONG, ASM_LONG); /* NULL terminating list */
+#else
+      fprintf (filvar,"\t%s\t0\n", ASM_LONG); /* NULL terminating list */
+#endif
       headindex++;
     }
 
@@ -2388,6 +2424,36 @@
 	  /* An idata$4 or idata$5 is one word long, and has an
 	     rva to idata$6.  */
 
+#ifdef DLLTOOL_MX86_64
+	  si->data = xmalloc (8);
+	  si->size = 8;
+
+	  if (exp->noname)
+	    {
+	      si->data[0] = exp->ordinal ;
+	      si->data[1] = exp->ordinal >> 8;
+	      si->data[2] = exp->ordinal >> 16;
+		  si->data[3] = exp->ordinal >> 24;
+		  si->data[4] = 0;
+		  si->data[5] = 0;
+		  si->data[6] = 0;
+	      si->data[7] = 0x80;
+	    }
+	  else
+	    {
+	      sec->reloc_count = 1;
+	      memset (si->data, 0, si->size);
+	      rel = xmalloc (sizeof (arelent));
+	      rpp = xmalloc (sizeof (arelent *) * 2);
+	      rpp[0] = rel;
+	      rpp[1] = 0;
+	      rel->address = 0;
+	      rel->addend = 0;
+	      rel->howto = bfd_reloc_type_lookup (abfd, BFD_RELOC_RVA);
+	      rel->sym_ptr_ptr = secdata[IDATA6].sympp;
+	      sec->orelocation = rpp;
+	    }
+#else
 	  si->data = xmalloc (4);
 	  si->size = 4;
 
@@ -2412,7 +2478,7 @@
 	      rel->sym_ptr_ptr = secdata[IDATA6].sympp;
 	      sec->orelocation = rpp;
 	    }
-
+#endif
 	  break;
 
 	case IDATA6:
@@ -2626,7 +2692,11 @@
   if (!no_idata5)
     {
       fprintf (f, "\t.section\t.idata$5\n");
-      fprintf (f, "\t%s\t0\n", ASM_LONG);
+#ifdef DLLTOOL_MX86_64
+      fprintf (f,"\t%s\t0\n\t%s\t0\n", ASM_LONG, ASM_LONG); /* NULL terminating list */
+#else
+      fprintf (f,"\t%s\t0\n", ASM_LONG); /* NULL terminating list */
+#endif
       fprintf (f, "fthunk:\n");
     }
 
@@ -2634,7 +2704,11 @@
     {
       fprintf (f, "\t.section\t.idata$4\n");
 
-      fprintf (f, "\t%s\t0\n", ASM_LONG);
+#ifdef DLLTOOL_MX86_64
+      fprintf (f,"\t%s\t0\n\t%s\t0\n", ASM_LONG, ASM_LONG); /* NULL terminating list */
+#else
+      fprintf (f,"\t%s\t0\n", ASM_LONG); /* NULL terminating list */
+#endif
       fprintf (f, "\t.section	.idata$4\n");
       fprintf (f, "hname:\n");
     }
@@ -2660,13 +2734,21 @@
   if (!no_idata4)
     {
       fprintf (f, "\t.section	.idata$4\n");
-      fprintf (f, "\t%s\t0\n", ASM_LONG);
+#ifdef DLLTOOL_MX86_64
+      fprintf (f,"\t%s\t0\n\t%s\t0\n", ASM_LONG, ASM_LONG); /* NULL terminating list */
+#else
+      fprintf (f,"\t%s\t0\n", ASM_LONG); /* NULL terminating list */
+#endif
     }
 
   if (!no_idata5)
     {
       fprintf (f, "\t.section	.idata$5\n");
-      fprintf (f, "\t%s\t0\n", ASM_LONG);
+#ifdef DLLTOOL_MX86_64
+      fprintf (f,"\t%s\t0\n\t%s\t0\n", ASM_LONG, ASM_LONG); /* NULL terminating list */
+#else
+      fprintf (f,"\t%s\t0\n", ASM_LONG); /* NULL terminating list */
+#endif
     }
 
 #ifdef DLLTOOL_PPC
diff -rNbu binutils_060913_org/binutils/testsuite/ChangeLog binutils_060913/binutils/testsuite/ChangeLog
--- binutils_060913_org/binutils/testsuite/ChangeLog	2006-08-15 20:23:10.000000000 +0200
+++ binutils_060913/binutils/testsuite/ChangeLog	2006-09-13 11:06:25.000000000 +0200
@@ -1,3 +1,12 @@
+2006-09-13	Kai Tietz	<Kai.Tietz@onevision.com>
+
+	* binutils-all/dlltool.exp:	Add support for target x86_64-pc-mingw64
+	* binutils-all/objcopy.exp:	Add support for target x86_64-pc-mingw64
+	* binutils-all/windres/windres.exp:	Add support for target x86_64-pc-mingw64
+	* binutils-all/windres/lang.rc:	xfail it as long as there is no windows.h
+	* binutils-all/windres/strtab1.rc:	xfail it as long as there is no windows.h
+	* lib/utils-lib.exp:	Adjust executable prefix detection (as .exe)
+
 2006-08-15  Thiemo Seufer  <ths@mips.com>
             Nigel Stephens  <nigel@mips.com>
             David Ung  <davidu@mips.com>
diff -rNbu binutils_060913_org/binutils/testsuite/binutils-all/copy-3.d binutils_060913/binutils/testsuite/binutils-all/copy-3.d
--- binutils_060913_org/binutils/testsuite/binutils-all/copy-3.d	2006-05-03 18:45:59.000000000 +0200
+++ binutils_060913/binutils/testsuite/binutils-all/copy-3.d	2006-09-11 15:53:34.000000000 +0200
@@ -3,7 +3,7 @@
 #objcopy: --set-section-flags .text=alloc,data
 #name: copy with setting section flags 3
 #source: bintest.s
-#not-target: *-*-aout *-*-*pe *-*-*coff i*86-*-cygwin* i*86-*-mingw32*
+#not-target: *-*-aout *-*-*pe *-*-*coff i*86-*-cygwin* i*86-*-mingw32* x86_64-*-mingw64*
 # The .text # section in PE/COFF has a fixed set of flags and these
 # cannot be changed.  We skip it for them.
 
diff -rNbu binutils_060913_org/binutils/testsuite/binutils-all/dlltool.exp binutils_060913/binutils/testsuite/binutils-all/dlltool.exp
--- binutils_060913_org/binutils/testsuite/binutils-all/dlltool.exp	2005-05-08 16:17:40.000000000 +0200
+++ binutils_060913/binutils/testsuite/binutils-all/dlltool.exp	2006-09-11 13:53:24.000000000 +0200
@@ -14,13 +14,14 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
 
-if {![istarget "i*86-*-*"]} {
+if {![istarget "i*86-*-*"] && ![istarget "x86_64-*-mingw64*"] } {
     return
 }
 
 if {![istarget "i*86-*-*pe*"] \
     && ![istarget "i*86-*-cygwin*"] \
-    && ![istarget "i*86-*-mingw32*"] } {
+    && ![istarget "i*86-*-mingw32*"] \
+    && ![istarget "x86_64-*-mingw64*"] } {
     set target_xfail "yes"
 } else {
     set target_xfail "no"
diff -rNbu binutils_060913_org/binutils/testsuite/binutils-all/objcopy.exp binutils_060913/binutils/testsuite/binutils-all/objcopy.exp
--- binutils_060913_org/binutils/testsuite/binutils-all/objcopy.exp	2006-06-23 18:23:09.000000000 +0200
+++ binutils_060913/binutils/testsuite/binutils-all/objcopy.exp	2006-09-11 13:54:42.000000000 +0200
@@ -443,7 +443,7 @@
 
 # Build a final executable.
 
-if { [istarget *-*-cygwin] || [istarget *-*-mingw32] } {
+if { [istarget *-*-cygwin] || [istarget *-*-mingw*] } {
     set test_prog "testprog.exe"
 } else {
     set test_prog "testprog"
diff -rNbu binutils_060913_org/binutils/testsuite/binutils-all/windres/lang.rc binutils_060913/binutils/testsuite/binutils-all/windres/lang.rc
--- binutils_060913_org/binutils/testsuite/binutils-all/windres/lang.rc	2001-07-19 01:56:41.000000000 +0200
+++ binutils_060913/binutils/testsuite/binutils-all/windres/lang.rc	2006-09-11 13:55:32.000000000 +0200
@@ -1,3 +1,4 @@
+//#xfail *-*-mingw64
 #include "windows.h"
 
 LANGUAGE 0, 0
diff -rNbu binutils_060913_org/binutils/testsuite/binutils-all/windres/strtab1.rc binutils_060913/binutils/testsuite/binutils-all/windres/strtab1.rc
--- binutils_060913_org/binutils/testsuite/binutils-all/windres/strtab1.rc	2001-07-19 01:56:41.000000000 +0200
+++ binutils_060913/binutils/testsuite/binutils-all/windres/strtab1.rc	2006-09-11 13:55:58.000000000 +0200
@@ -1,3 +1,4 @@
+//#xfail *-*-mingw64
 #include "windows.h"
 
 LANGUAGE 0, 0
diff -rNbu binutils_060913_org/binutils/testsuite/binutils-all/windres/windres.exp binutils_060913/binutils/testsuite/binutils-all/windres/windres.exp
--- binutils_060913_org/binutils/testsuite/binutils-all/windres/windres.exp	2005-05-08 16:17:41.000000000 +0200
+++ binutils_060913/binutils/testsuite/binutils-all/windres/windres.exp	2006-09-11 13:56:48.000000000 +0200
@@ -19,13 +19,14 @@
 
 # Written by DJ Delorie <dj@redhat.com>
 
-if {![istarget "i*86-*-*"]} {
+if {![istarget "i*86-*-*"] && ![istarget "x86_64-*-mingw64"] } {
     return
 }
 
 if {![istarget "i*86-*-*pe*"] \
     && ![istarget "i*86-*-cygwin*"] \
-    && ![istarget "i*86-*-mingw32*"] } {
+    && ![istarget "i*86-*-mingw32*"] \
+    && ![istarget "x86_64-*-mingw64*"] } {
     set target_xfail "yes"
 } else {
     set target_xfail "no"
diff -rNbu binutils_060913_org/binutils/testsuite/lib/utils-lib.exp binutils_060913/binutils/testsuite/lib/utils-lib.exp
--- binutils_060913_org/binutils/testsuite/lib/utils-lib.exp	2006-04-26 15:37:05.000000000 +0200
+++ binutils_060913/binutils/testsuite/lib/utils-lib.exp	2006-09-11 13:57:44.000000000 +0200
@@ -161,7 +161,7 @@
 #	Returns target executable extension, if any.
 #
 proc exe_ext {} {
-    if { [istarget *-*-mingw32] || [istarget *-*-cygwin*] } {
+    if { [istarget *-*-mingw*] || [istarget *-*-cygwin*] } {
         return ".exe"
     } else {
         return ""
